using System;
using System.Web.SessionState;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Xml;
using System.Text;

namespace DynamicVisio
{
	/// <summary>
	/// Summary description for _Default.
	/// </summary>
	public class Dynamic : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnUpload;
		protected System.Web.UI.HtmlControls.HtmlInputFile uploadFile;
		protected System.Web.UI.WebControls.Label lblStatus;
		protected System.Web.UI.WebControls.DropDownList ddlColor;

		private XmlDocument VisioXMLDoc
		{
			get 
			{
				if ((XmlDocument) Session["VisioXMLDoc"] == null)
					Session["VisioXMLDoc"] = new XmlDocument();
				return (XmlDocument) Session["VisioXMLDoc"];
			}
			set	{Session["VisioXMLDoc"] = value;}
		}

		private string VisioFileNm
		{
			get 
			{
				string s = (string)Session["VisioFileNm"];
				return ((s == null) ? String.Empty : s);
			}
			set {Session["VisioFileNm"] = value;}
		}

	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (VisioFileNm != string.Empty)
			{
				this.ddlColor.Enabled = true;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnUpload.Click += new System.EventHandler(this.btnUpload_Click);
			this.ddlColor.SelectedIndexChanged += new System.EventHandler(this.RenderVisioDiagram);

		}
		#endregion

		private void btnUpload_Click(object sender, System.EventArgs e)
		{
			// Save Posted Visio File
			VisioFileNm = Path.GetTempPath() + 
				uploadFile.Value.Substring(uploadFile.Value.LastIndexOf(@"\")+1);
			uploadFile.PostedFile.SaveAs(VisioFileNm);

			// Read Visio XML file into an application cached XmlDocument
			XmlTextReader xtr = new XmlTextReader(VisioFileNm);
			xtr.WhitespaceHandling = WhitespaceHandling.All;
			VisioXMLDoc.Load(xtr);
			xtr.Close();
	
			// Display the diagram
			ddlColor.Enabled = true;
			RenderVisioDiagram(null, null);

			lblStatus.Text = "Successful upload!";
		}

		private void RenderVisioDiagram(object sender, System.EventArgs e)
		{
			// Modify Visio's XML 
			Application.Lock();
			XmlNodeList xShapes = VisioXMLDoc.GetElementsByTagName("Shape");
			foreach (XmlNode xnod in xShapes)
				ChangeShapeAttributes(xnod);
			Application.UnLock();

			// Save the modified XML to a file.
			XmlTextWriter xtw = new XmlTextWriter(VisioFileNm, 
				System.Text.UTF8Encoding.UTF8);
			VisioXMLDoc.WriteTo(xtw);
			xtw.Close();

			// Call Visio to save the XML file to a web page.
			VisioDotNet.Application app = new VisioDotNet.ApplicationClass();
			app.Documents.Open(VisioFileNm);
			app.Addons.get_ItemU("SaveAsWeb").Run(
				"/quiet=True /openbrowser=False /target=" + 
				Request.PhysicalApplicationPath + "VisioDiagram");
			app.Quit();
		}

		public void ChangeShapeAttributes(XmlNode xnod)
		{
			XmlNamedNodeMap attrs = xnod.Attributes;
			string id = attrs.GetNamedItem("ID").Value.ToString();

			XmlNodeList xchilds = xnod.ChildNodes;
			foreach (XmlNode node in xnod.ChildNodes)
			{
				if (node.Name == "Fill")
				{
					foreach (XmlNode fillnode in node.ChildNodes)
					{
						if (fillnode.Name == "FillForegnd")
						{
							fillnode.InnerText = 
								ddlColor.SelectedValue.ToString();
							break;
						}
					}
				}
			}
		}
	}
}
